/* GCC */

#include <fstream>
using namespace std;

struct Sportsman
{
    Sportsman *WantsToBeWith;       
    Sportsman *IsWith;
    int WhenIsWithChanged;
};

Sportsman sportsmen[200000];
int n;

void Load()
{
    ifstream in;
    in.open("village.in");
    in>>n;
    
    int tmp;
    for(int i = 0; i < n; i++)
    {
         in>>tmp;
         sportsmen[i].WantsToBeWith = &sportsmen[tmp-1];
    }     
    
    in.close();
}

void Save(int what)
{
    ofstream out; 
    out.open("village.out");
    out<<what<<endl;
    out.close();
}

void Reset(int step)
{
    for(int i = 0; i < n; i++)
    {
         if(step == 0 || sportsmen[i].WhenIsWithChanged == step)
         {
             sportsmen[i].IsWith = NULL;
             sportsmen[i].WhenIsWithChanged = -1;
         }
    }     
}

void Poseliti(Sportsman &a, Sportsman &b, int step)
{
    a.IsWith = &b;
    b.IsWith = &a;
    a.WhenIsWithChanged = step;
    b.WhenIsWithChanged = step;
}

int Next(int from)
{
     for(int i = ++from; i < n; i++)
     {
          if(!sportsmen[i].IsWith && !sportsmen[i].WantsToBeWith->IsWith)
          {
              return i;
          }
     }
     return -1;
}

int Result()
{
    int result = 0;
    for(int i = 0; i < n; i++)
    {
         if(sportsmen[i].WantsToBeWith == sportsmen[i].IsWith)
         {
             result++;
         }
    }
    return result;
};

int BiggestFrom3 (int a, int b, int c)
{
    if(a > b)
    {
        return a > c ? a : c;     
    }
    else
    {
        return b > c ? b : c;
    }
}

int Solve(int step)
{
    
    int biggestOne = 0;
    
    for(int i = 0; i < n; i++)
    {  
         Reset(step);
            
         if(sportsmen[i].IsWith || sportsmen[i].WantsToBeWith->IsWith)
         {
             i = Next(i);
             if(i == -1)
             {       
                  break;
             }
         }
    
         Poseliti(sportsmen[i], *sportsmen[i].WantsToBeWith, step);
         
         biggestOne = BiggestFrom3(biggestOne, Solve(step + 1), Result());
    }
    
    return biggestOne;
}

int main()
{
    Load();
    Save(Solve(0));
}
